<template>
    <div class="history">
        <!-- Header -->
        <div
            class="
                history-header
                row
                q-pl-md
                helvetica-neue-medium
                font-16
                text-white
                justify-start
                items-center
            "
        >
            {{ name ? name : $t('home.history') }}
        </div>

        <!-- History Scroll -->
        <div
            class="history-scroll row"
            ref="chatArea"
            @scroll="handleScroll"
            v-if="state.messages.length > 0"
        >
            <div
                class="history-contain row"
                :id="'conversation-' + message.conversationId"
                v-for="(message, index) in state.messages"
                v-bind:key="index"
            >
                <!-- System Message -->
                <div
                    class="row justify-center text-center"
                    v-if="message.type == MessageType.SYSTEM"
                >
                    <div class="col-12">
                        <p class="font-12 text-777777">
                            {{ message.localization?.en }}
                        </p>
                    </div>
                </div>

                <!-- Normal Message -->
                <div
                    v-if="message.type != MessageType.SYSTEM"
                    class="row"
                    :class="[
                        message.user?.id == selectedUserId ? '' : ' justify-end'
                    ]"
                >
                    <div
                        class="items-center q-ma-sm q-pa-md"
                        :class="[
                            message.user?.id == selectedUserId
                                ? 'history-item'
                                : 'history-item-user'
                        ]"
                    >
                        <div class="agent-name">
                            {{ message?.user.name }}
                        </div>

                        <!-- Reply -->
                        <bubble-reply
                            class="justify-end row"
                            v-if="message.repliedMessage"
                            :message="message"
                            :repliedMessage="message.repliedMessage"
                        />
                        <!-- Text -->
                        <bubble-text
                            v-if="
                                ![
                                    MessageType.VIDEO,
                                    MessageType.IMAGE,
                                    MessageType.STICKER,
                                    MessageType.EVENT_REMINDER,
                                    MessageType.DOCUMENT,
                                    MessageType.AUDIO,
                                    MessageType.SYSTEM
                                ].includes(parseInt(`${message.type}`))
                            "
                            :message="message"
                            :loading="loading"
                        />

                        <!-- Image -->
                        <bubble-image
                            v-if="message.type == MessageType.IMAGE"
                            :message="message"
                        />

                        <!-- Video -->
                        <bubble-video
                            v-if="message.type == MessageType.VIDEO"
                            :message="message"
                        />

                        <!-- Document -->
                        <bubble-document
                            v-if="message.type == MessageType.DOCUMENT"
                            :message="message"
                        />

                        <!-- Audio -->
                        <bubble-audio
                            v-if="message.type == MessageType.AUDIO"
                            :message="message"
                        />
                    </div>
                </div>
            </div>
        </div>

        <!-- Empty chat preview history -->
        <div
            v-else
            class="history-scroll col-12 row justify-center items-center"
        >
            <div class="row justify-center items-center">
                <q-icon size="lg" name="img:icons\sad.png"></q-icon>
                <span
                    class="
                        row
                        justify-center
                        items-center
                        helvetica-neue
                        font-14
                        col-12
                        q-pt-sm
                    "
                >
                    {{ $t('home.noHistory') }}
                </span>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
/* eslint-disable @typescript-eslint/no-floating-promises */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-call */
import { defineComponent, reactive, ref, watch, nextTick, computed } from 'vue';
import moment from 'moment';
import { useStore } from 'src/store';
import { mapGetters } from 'vuex';
import { Message } from 'src/services/models/Message';
import { MessageType } from 'src/services/enums/MessageType';
import BubbleText from '../../components/chats/BubbleText.vue';
import BubbleImage from '../../components/chats/BubbleImage.vue';
import BubbleVideo from '../../components/chats/BubbleVideo.vue';
import BubbleDocument from '../../components/chats/BubbleDocument.vue';
import BubbleAudio from '../../components/chats/BubbleAudio.vue';
import BubbleReply from '../../components/chats/BubbleReply.vue';
import { orderBy, debounce, size } from 'lodash';

export default defineComponent({
    name: 'HistoryList',
    props: {
        name: {
            type: String,
            required: false
        }
    },
    components: {
        BubbleText,
        BubbleImage,
        BubbleVideo,
        BubbleDocument,
        BubbleAudio,
        BubbleReply
    },
    computed: {
        ...mapGetters({
            conversations: 'conversation/getConversationsHistory'
        })
    },
    setup() {
        // store
        const store = useStore();
        const chatArea = ref<any>(null);
        const isLoadingTop = ref(false);
        const selectedUserId = computed(() => {
            return store.state.conversation.selectedUserID;
        });
        const selectedConversationId = computed(() => {
            return store.state.conversation.selectedConversationID;
        });
        const messages = computed<Message[]>(() => {
            return orderBy(
                store.state.message.messagesHistory,
                ['createdAt'],
                ['asc']
            );
        });

        // data
        let state = reactive({
            conversations: [] as any,
            messages: messages,
            currentConversationID: ''
        });
        let previousScroll = 0;
        let page = 1;
        let stillHaveResult = true;
        let isInMiddle = false;
        let scrollDirection: 'top' | 'bottom' = 'top';
        let currentHeight = 0;
        let isApiCall = false;
        let isReset = false;
        let nextIsScrollInMiddle = false;

        // watch
        watch(selectedUserId, async (currentValue, oldValue) => {
            if (currentValue != oldValue) {
                await store.dispatch(
                    'conversation/clearAllConversationsHistory'
                );
                await store.dispatch('message/clearAllMessagesHistory');
            }
            if (currentValue) {
                page = 1;
                stillHaveResult = true;
                getMessages(selectedUserId.value);
            }
        });

        watch(selectedConversationId, (currentValue, oldValue) => {
            if (currentValue != oldValue) {
                isLoadingTop.value = false;
            }
        });

        // methods
        const getMessages = async (selectedUserId: any) => {
            isLoadingTop.value = true;

            isApiCall = true;

            const result = await store.dispatch('message/getMessagesHistory', {
                userId: selectedUserId,
                page,
                isDownward: 0
            });

            if (result.messages.length == 0) {
                stillHaveResult = false;
            }

            if (page == 1) {
                scrollToBottom();
            }

            isLoadingTop.value = false;
        };

        const handleScroll = () => {
            const currentScroll: number = chatArea.value?.scrollTop ?? 0;
            const maxScroll: number = chatArea.value?.scrollHeight ?? 0;

            try {
                if (previousScroll > currentScroll) {
                    scrollDirection = 'top';
                    if (
                        currentScroll < 0.05 * maxScroll ||
                        currentScroll == 0
                    ) {
                        loadTop();
                    }
                } else if (previousScroll < currentScroll) {
                    scrollDirection = 'bottom';
                }
            } catch (err: any) {}

            previousScroll = currentScroll;
        };

        const loadTop = debounce(
            () => {
                if (stillHaveResult) {
                    page += 1;
                    getMessages(store.state.conversation.selectedUserID);
                }
            },
            500,
            {
                leading: true,
                trailing: false
            }
        );

        store.watch(
            (state) => size(state.message.messagesHistory),
            (newLength: number, oldLength: number) => {
                // First load
                if (oldLength == 0 && newLength > 0) {
                    if (!isInMiddle) {
                        scrollToBottom();
                    } else {
                        isInMiddle = false;
                    }
                }
                // Load top
                else {
                    if (currentHeight > 0 && chatArea.value) {
                        if (isApiCall) {
                            if (
                                chatArea.value?.scrollTop <
                                0.15 * chatArea.value?.scrollHeight
                            ) {
                                nextTick(() => {
                                    setTimeout(() => {
                                        if (chatArea.value) {
                                            chatArea.value.scrollTop =
                                                chatArea.value.scrollHeight -
                                                currentHeight;
                                        }
                                    });
                                });
                            }
                        } else {
                            // New message coming in
                            if (
                                (chatArea.value?.scrollTop as number) +
                                    (chatArea.value?.offsetHeight as number) >
                                0.95 * chatArea.value?.scrollHeight
                            ) {
                                scrollToBottom();
                            }
                        }
                    }
                    // Jump scroll
                    else {
                        if (!isInMiddle) {
                            if (scrollDirection == 'bottom') {
                                if (isReset) {
                                    isReset = false;
                                    scrollToBottom();
                                } else {
                                    nextTick(() => {
                                        setTimeout(() => {
                                            if (chatArea.value) {
                                                chatArea.value.scrollTop =
                                                    currentHeight -
                                                    chatArea.value
                                                        ?.offsetHeight;
                                            }
                                        });
                                    });
                                }
                            } else {
                                nextTick(() => {
                                    setTimeout(() => {
                                        if (chatArea.value) {
                                            chatArea.value.scrollTop =
                                                chatArea.value.scrollHeight -
                                                currentHeight;
                                        }
                                    });
                                });
                            }
                        } else {
                            nextTick(() => {
                                setTimeout(() => {
                                    if (chatArea.value) {
                                        chatArea.value.scrollTop = 0;
                                    }
                                });
                            });
                        }
                    }
                }

                isApiCall = false;
                currentHeight = chatArea.value?.scrollHeight;
            }
        );

        const scrollToBottom = () => {
            if (nextIsScrollInMiddle) {
                nextIsScrollInMiddle = false;
                scrollDirection = 'bottom';
                isReset = true;

                // Reset messageList
                store.dispatch('message/resetHistory');
            } else {
                scrollDirection = 'bottom';
                nextTick(() => {
                    setTimeout(() => {
                        if (chatArea.value) {
                            chatArea.value.scrollTop =
                                chatArea.value.scrollHeight -
                                chatArea.value.offsetHeight;
                            currentHeight = chatArea.value.scrollHeight;
                        }
                    });
                });

                const messageStatus = store.state.message.messageStatus;
                if (messageStatus == 200 || messageStatus == 201) {
                    // getMessages();
                }
            }
        };

        return {
            moment,
            state,
            chatArea,
            handleScroll,
            scrollToBottom,
            selectedUserId,
            MessageType
        };
    }
});
</script>
